#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include "SerialComm.h"
#include <time.h>
#include <sys/time.h>


int main(int argc, char *argv[]) {	
	
        //FILE* commands = fopen("commands", "w");
        SerialComm *comm;
        char *port_name = "/dev/rfcomm0\0";
	int err;
        int i=0, j=0;
        char command[20];
        char data[100];
        int speed_left = 0, speed_right = 0;
        char high_left, low_left, high_right, low_right;
        struct timeval start, end;
        long prepTime = 0;

        comm = new SerialComm();

        err = comm->connect(port_name);
        if(err == -1) {
                perror("Cannot open serial port: ");
                return 1;
        }

        // clear output buffer
        memset(command, 0x0, 20);
        sprintf(command, "\r");
        comm->writeData(command, 1, 6000);
        comm->readData(data, 100, 90000);
        sprintf(command, "V\r");
        comm->writeData(command, 2, 2000);
        memset(data, 0x0, 100);
        comm->readData(data, 100, 200000);
        fprintf(stderr, "version = %s\n", data);


        gettimeofday(&start, NULL);

        speed_left = 0;
        high_left = (speed_left>>8) & 0xFF;
        low_left = speed_left & 0xFF;
        speed_right = 0;
        high_right = (speed_right>>8) & 0xFF;
        low_right = speed_right & 0xFF;
        memset(command, 0x0, 20);
        sprintf(command, "%c%c%c%c%c%c",-'D', low_left, high_left, low_right, high_right,0);

        gettimeofday(&end, NULL);

        prepTime = ((end.tv_sec * 1000000 + end.tv_usec) - (start.tv_sec * 1000000 + start.tv_usec));
        printf("Command preparation time: %ld microsec\n", prepTime);

        gettimeofday(&start, NULL);

        for(i=799; i>=0; i--) {
            for(j=0; j<24; j++) {
                speed_left = i;
                high_left = (speed_left>>8) & 0xFF;
                low_left = speed_left & 0xFF;
                speed_right = i;
                high_right = (speed_right>>8) & 0xFF;
                low_right = speed_right & 0xFF;
                memset(command, 0x0, 20);
                sprintf(command, "%c%c%c%c%c%c",-'D', low_left, high_left, low_right, high_right,0);
                comm->simple_write(command, 6);
                //fwrite(command, 1, 6, commands);
            }
        }

        gettimeofday(&end, NULL);


        printf("Total time: %ld microsec\n", ((end.tv_sec * 1000000 + end.tv_usec) - (start.tv_sec * 1000000 + start.tv_usec)));

        printf("Sending time: %ld microsec\n", ((end.tv_sec * 1000000 + end.tv_usec) - (start.tv_sec * 1000000 + start.tv_usec)) - prepTime*19200);

        comm->disconnect();

        //fclose(commands);

}

